#pragma once

#include "HandshakeResponseMessage.h"
#include "PixelMessage.h"

HandshakeResponseMessage::HandshakeResponseMessage() : PixelMessage()
{
}

HandshakeResponseMessage::HandshakeResponseMessage(byte* rawMessage) : PixelMessage(rawMessage)
{
	// The position of the start of the message body
	void* messageBodyStart = static_cast<void*>(rawMessage + PixelMessage::MESSAGE_HEADER_LENGTH);
	
	Id = *(static_cast<unsigned int*>(messageBodyStart));
}
