#pragma once

#include "InfoRequestMessage.h"
#include "PixelMessage.h"

InfoRequestMessage::InfoRequestMessage() : PixelMessage()
{
}

InfoRequestMessage::InfoRequestMessage(byte* rawMessage) : PixelMessage(rawMessage)
{
	// The position of the start of the message body
	char* messageBodyPointer = static_cast<char*>(static_cast<void*>(rawMessage + PixelMessage::MESSAGE_HEADER_LENGTH));
	
	Key = new char[strlen(messageBodyPointer) + sizeof(char)];
	strcpy(Key, messageBodyPointer);
}

InfoRequestMessage::~InfoRequestMessage()
{
	delete[] Key;
}
