#pragma once

#include "MoveMessage.h"
#include "PixelMessage.h"

MoveMessage::MoveMessage() : PixelMessage()
{
}

MoveMessage::MoveMessage(byte* rawMessage) : PixelMessage(rawMessage)
{
	// The position of the start of the message body
	void* messageBodyStart = static_cast<void*>(rawMessage + PixelMessage::MESSAGE_HEADER_LENGTH);
	
	MovementType = *(static_cast<byte*>(messageBodyStart));
	TickCount =  *(static_cast<unsigned short*>(messageBodyStart + 1));
}
