﻿using System;
using System.Text;

namespace PixelHub.Server.PixelMessages
{
	public class HandshakeRequestMessage : PixelMessage
	{
		/// <summary>
		/// The type of PixelBot the client thinks it is. Rather like a user-agent string actually.
		/// </summary>
		public string PixelBotType = string.Empty;

		public override byte[] Payload {
			get {
				return Encoding.UTF8.GetBytes(PixelBotType);
			}
			protected set {
				PixelBotType = Encoding.UTF8.GetString(value);
			}
		}

		public new MessageTypes MessageType { get; private set; } = MessageTypes.HandshakeRequest;
		
		public HandshakeRequestMessage()
		{
		}
	}
}

